import RPi.GPIO as GPIO
import alsaaudio
import numpy

relay = 3
nframe  = 500
rate    = 8000
threshold = 10000
devicestr = 'sysdefault:CARD=U0x46d0x821'

devices = alsaaudio.pcms(alsaaudio.PCM_CAPTURE)
# print(devices)
pcm = alsaaudio.PCM(type=alsaaudio.PCM_CAPTURE,
                    mode=alsaaudio.PCM_NORMAL,
                    device=devicestr,
                    cardindex=-1)
GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)
GPIO.setup(relay, GPIO.OUT)

pcm.setrate(rate)
pcm.setchannels(1)
for i in range(nframe):
    data = pcm.read()
    fdata = numpy.fromstring(data[1],dtype=numpy.int16)
    total = 0L
    for datum in fdata[0:16]:
        total += datum/256*datum/256
    print total
    # Written by participants of the talk
    if total>threshold:
        GPIO.output(relay, 1)
    else:
        GPIO.output(relay, 0)
