import alsaaudio
import string
import time
# import struct
import numpy

nframe  = 1
rate    = 8000
psize   = 10000000
devices = alsaaudio.pcms(alsaaudio.PCM_CAPTURE)
print(devices)
p = alsaaudio.PCM(type=alsaaudio.PCM_CAPTURE,
                  mode=alsaaudio.PCM_NORMAL,
                  device='sysdefault:CARD=U0x46d0x821',
                  cardindex=-1)
p.setrate(rate)
p.setchannels(1)

frames=[]
for i in range(nframe):
    data = p.read()
    frames+=[data[1]]
nframe = data[0]
print("       rate = "+str(rate))
print("     nframe = "+str(nframe))

tframe = 0
for frame in frames:
    tframe += len(frame)

print("     tframe = " + str(tframe))
print("record time = " + str(1.0*tframe/rate/2))

fdata = numpy.fromstring(frames[0],dtype=numpy.int16)
# fdata = struct.unpack('<h', frames[0])
print(len(fdata))
for datum in fdata[0:10]:
    print(datum)
