import alsaaudio
import string
import time

nframe  = 100
rate    = 8000
psize   = 10000000
devices = alsaaudio.pcms(alsaaudio.PCM_CAPTURE)
print(devices)
p = alsaaudio.PCM(type=alsaaudio.PCM_CAPTURE,
                  mode=alsaaudio.PCM_NORMAL,
                  device='sysdefault:CARD=U0x46d0x821',
                  cardindex=-1)
p.setrate(rate)
p.setchannels(1)
# p.setformat(alsaaudio.PCM_FORMAT_S16_LE)
# p.setperiodsize(psize)

s = alsaaudio.PCM()
s.setrate(16000)
s.setchannels(1)
# s.setperiodsize(psize)

tstart = time.time()
print("tstart="+str(tstart))
frames=[]
for i in range(nframe):
    data = p.read()
    frames+=[data[1]]
nframe = data[0]
tend = time.time()
print("       rate = "+str(rate))
print("     nframe = "+str(nframe))
print("       tend = "+str(tend))
print("       diff = "+str(tend-tstart))
print("  diff*rate = "+str((tend-tstart)*rate))
print("diff*nframe = "+str((tend-tstart)*nframe))

tframe = 0
for frame in frames:
    tframe += len(frame)

print("     tframe = " + str(tframe))
print("record time = " + str(1.0*tframe/rate/2))

for frame in frames:
    s.write(frame)
